Package org.bukkit.inventory

# Interface CraftingInventory

All Superinterfaces:
  `Inventory`, `Iterable<ItemStack>`

public interface CraftingInventory extends Inventory
Interface to the crafting inventories

## Method Summary

Modifier and Type
Method
Description
`@NotNull ItemStack[]`
`getMatrix()`
Get the contents of the crafting matrix.
`@Nullable Recipe`
`getRecipe()`
Get the current recipe formed on the crafting inventory, if any.
`@Nullable ItemStack`
`getResult()`
Check what item is in the result slot of this crafting inventory.
`void`
`setMatrix(@NotNull ItemStack[] contents)`
Replace the contents of the crafting matrix
`void`
`setResult(@Nullable ItemStack newResult)`
Set the item in the result slot of the crafting inventory.

### Methods inherited from interface org.bukkit.inventory.Inventory

`addItem, all, all, clear, clear, close, contains, contains, contains, contains, containsAtLeast, first, first, firstEmpty, getContents, getHolder, getHolder, getItem, getLocation, getMaxStackSize, getSize, getStorageContents, getType, getViewers, isEmpty, iterator, iterator, remove, remove, removeItem, removeItemAnySlot, setContents, setItem, setMaxStackSize, setStorageContents`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Method Details

### getResult

@Nullable @Nullable ItemStack getResult()
Check what item is in the result slot of this crafting inventory.

Returns:
  The result item.

### getMatrix

@NotNull @NotNull ItemStack[] getMatrix()
Get the contents of the crafting matrix.

Returns:
  The contents. Individual entries may be null.

### setResult

void setResult(@Nullable @Nullable ItemStack newResult)
Set the item in the result slot of the crafting inventory.

Parameters:
  `newResult` - The new result item.

### setMatrix

void setMatrix(@NotNull @NotNull ItemStack[] contents)
Replace the contents of the crafting matrix

Parameters:
  `contents` - The new contents. Individual entries may be null.
Throws:
  `IllegalArgumentException` - if the length of contents is greater than the size of the crafting matrix.

### getRecipe

@Nullable @Nullable Recipe getRecipe()
Get the current recipe formed on the crafting inventory, if any.

Returns:
  The recipe, or null if the current contents don't match any recipe.